<template>
  <el-dialog
    v-model="dialogVisible"
    :close-on-click-modal="false"
    :title="parameter.title"
    :destroy-on-close="true"
    :width="parameter.width"
    :top="parameter.top"
    draggable
  >
    <ProFrom ref="proFormRef" :field-list="parameter.fieldList" :options="_options" :model="parameter.model" />
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" v-if="parameter.isEdit" :loading="butLoading" @click="handleSubmit">确认</el-button>
        <el-button @click="handleCancel">取消</el-button>
      </span>
    </template>
  </el-dialog>
</template>

<script setup lang="ts" name="FormDialog">
import { ref } from 'vue'
import ProFrom from '@/components/ProFormOld/index.vue'
import { ElMessage } from 'element-plus'

export interface FormParameterProps {
  title: string // 标题
  width?: number // 弹框宽度
  labelWidth?: number // label宽度
  api?: (params: any) => Promise<any> // 表单提交api
  fieldList: Form.FieldItem[] // 动态表单字段
  isEdit?: boolean // 是否编辑
  top?: string // 离顶部距离
  model?: Record<string, any> // 表单数据对象
  getTableList?: () => void // 获取表格数据的Api
}
// dialog状态
const dialogVisible = ref(false)
const butLoading = ref(false)
// 父组件传过来的参数
const parameter = ref<FormParameterProps>({
  title: '',
  width: 500,
  top: '8vh',
  fieldList: [],
  isEdit: true
})
const _options: Form.Options = {
  labelWidth: 100,
  hasFooter: false,
  disabled: false
}
const proFormRef = ref<InstanceType<typeof ProFrom> | null>(null)
// 表单提交校验
const handleSubmit = () => {
  const formEl = proFormRef.value?.formRef
  butLoading.value = true
  if (!formEl) return
  formEl.validate(valid => {
    if (valid) {
      parameter.value.api!(parameter.value.model).then(res => {
        if (res.code == 200) {
          proFormRef.value?.resetForm(formEl)
          ElMessage.success('操作成功')
          dialogVisible.value = false
          parameter.value.getTableList && parameter.value.getTableList()
        } else {
          console.log('message', res.message)
        }
      })
      butLoading.value = false
    }
  })
}

// 取消按钮，重置表单，关闭弹框
const handleCancel = () => {
  const formEl = proFormRef.value?.formRef
  if (!formEl) return
  proFormRef.value?.resetForm(formEl)
  butLoading.value = false
  dialogVisible.value = false
}

// 接收父组件参数
const openDialog = (params: FormParameterProps) => {
  parameter.value = { ...parameter.value, ...params }
  _options.disabled = !parameter.value.isEdit
  butLoading.value = false
  dialogVisible.value = true
}

defineExpose({
  openDialog
})
</script>
